unit Util;


interface

uses Windows, Controls, Printers, Messages, SysUtils, Dialogs, Classes, OrNet, Orfn, comctrls,
Inifiles;


function IsMouseOver (Control: TControl): boolean;
function CurrentIndex(exn, totn : integer): integer;
function GetDefaultPrinterName : string;
function SubSetHOTeamMembers(const TM, StartFrom: string; Direction, PatFlg: Integer): TStrings;
function SubSetHOTeamMembersByClass(const TM, CLS, StartFrom: string; Direction: Integer): TStrings;
function SubSetOrderableItems(const StartFrom: string; Direction: Integer): TStrings;
Procedure ListofHOPatientsByPrv(RtnList : TStrings; TM, PRV : String);
function SubSetOfInPatients(const StartFrom: string; Direction: Integer): TStrings;
function findDup(str : String; slist : TStrings): Boolean;
function GetFileAge(Fname : String): String;
function IsvalidWindowsfilename(f: String): Boolean;
function RemoveChar(s, rm, rp : String): String;
function DeleteLineBreaks(const S: string): string;
function TextExtend(s, rm : String): String;

implementation

function findDup(str : String; slist : TStrings): Boolean;
var
flg : Boolean;
i : integer;
begin
Result := False;
flg := True;
i := 0;
if slist.count > 0 then
begin
  while flg do
    begin
      if str = Piece(slist[i],'^',1) then
         begin
          flg := False;
          Result := True;
         end
      else
         begin
           inc(i);
           if i = slist.count then flg := False;
         end;
    end;
end;
end;



function GetDefaultPrinterName : string;
Var
   device : String;
   WinIni: TIniFile;
Begin
  Result := '';
  WinIni := TIniFile.Create('WIN.INI');
  try
    // Get the current default printer
    device := WinIni.ReadString('windows', 'device', ',,');
    if device = '' then device := ',,';
    Result := piece(device,',',1);
  finally
    WinIni.Free;
  end;
end;

function CurrentIndex(exn, totn : integer): integer;
begin

  Result := exn;

  if (Result = 0) and (totn > 1) then Result := 0
  else
  if (Result=0) and ( totn =1) then Result := -1
  else
  if (Result <= totn -1) then Result := Result -1;
end;

function GetFileAge(Fname : String): String;
begin
Result := '';
if FileExists(Fname) then
 begin
  Result := DateTimeToStr(FileDateToDateTime(FileAge(Fname)));
 end;
end;

function IsMouseOver (Control: TControl): boolean;
var p: TPoint;
begin
  { get absolute coordinates }
  if GetCursorPos (p) then begin
    { convert to relative coordinates of component }
    p := Control.ScreenToClient (p);
    { coordinates within Control? }
    Result := (p.x >= 0) and (p.x <= Control.Width) and
      (p.y >= 0) and (p.y <= Control.Height);
  end
  else
    { this should never happen, but who knows... }
    Result := false;
end;

function IsvalidWindowsfilename(f: String): Boolean;
var
  i, found: Integer;
begin
 result := False;
 found := 0;
 for i := 0 to Length(f) do
 if pos(f[i], '\/:*?"<>|.') > 0 then inc(found);

if found = 0 then result := True;
end;

function  RemoveChar(s, rm, rp : String): String;
var
p, l : integer;
Done : boolean;
c : Char;
s1 : String;
begin
Done := False;
while not Done do
begin
  p := pos(rm, s);
  if p > 0  then
  begin
      Delete(s,p,Length(rm));
      Insert(rp,s,p);
    end
  else   Done := True;

  result := s;
end;
end;

//remove Linebreaks and replace with a space - About.com Delph programming tips
function DeleteLineBreaks(const S: string): string;
var
   Source, SourceEnd: PChar;
begin
   Source := Pointer(S) ;
   SourceEnd := Source + Length(S) ;
   while Source < SourceEnd do
   begin
     case Source^ of
       #10: Source^ := #32;
       #13: Source^ := #32;
     end;
     Inc(Source) ;
   end;
   Result := S;
end;


function TextExtend(S, rm : String): String;
var
p, l : integer;
Done : boolean;
c : Char;
s1 : String;
c1, c2 : Char;
begin
Done := False;
while not Done do
begin
  p := pos(rm, s);
  if p > 0  then
  begin
    c := s[p+Length(rm)];
    if (c in ['A'..'Z','0'..'9']) then
    begin
      if c in ['0'..'9'] then
        begin
          c1 := s[p+Length(rm)+1];
          c2 := s[p+Length(rm)+2];
          if (pos(c1,'.)-')>0)or ((c in ['0'..'9']) and (c1 in ['0'..'9']) and (pos(c2,'.)-')>0)) then
            begin
              s1 := s1 + copy(s,1,p+Length(rm));
              s := copy(s,P+Length(rm)+1,Length(s));
            end
            else
              begin
                Delete(s,p,Length(rm));
                Insert(' ',s,p);
                s1 := s1 + copy(s,1,p+1);
                s := copy(s,p+2,Length(s));
              end;
         end
      else
         begin       //c in ['A'..'Z']
            s1 := s1 + copy(s,1,p+Length(rm));
            s := copy(s,P+Length(rm)+1,Length(s));
          end;
     end
     else
       if (c in ['a'..'z']) or (c in ['0'..'9']) then
        begin
           Delete(s,p,Length(rm));
           Insert(' ',s,p);
           s1 := s1 + copy(s,1,p+1);
           s := copy(s,p+2,Length(s));
        end
       else
          begin
             s1 := s1 + copy(s,1,p+Length(rm));
             s := copy(s,P+Length(rm)+1,Length(s));
          end;
     end
     else
        begin
           Done := True;
           if Length(s)>0 then s1 := s1 + s;
           s := s1;
        end;
  end;
  result := s;
end;

function SubSetHOTeamMembers(const TM, StartFrom: string; Direction, PatFlg: Integer): TStrings;
{ returns a pointer to a list of persons (for use in a long list box) -  The return value is
  a pointer to RPCBrokerV.Results, so the data must be used BEFORE the next broker call! }
begin
  CallV('CRHD HOT PROVIDER LIST2', [TM, StartFrom, Direction, PatFlg]);
  MixedCaseList(RPCBrokerV.Results);
  Result := RPCBrokerV.Results;
end;


function SubSetHOTeamMembersByClass(const TM, CLS, StartFrom: string; Direction: Integer): TStrings;
{ returns a pointer to a list of persons (for use in a long list box) -  The return value is
  a pointer to RPCBrokerV.Results, so the data must be used BEFORE the next broker call! }
begin
  CallV('CRHD HOT PROVIDER BY CLASS', [TM,  startFrom, Direction, CLS]);
  MixedCaseList(RPCBrokerV.Results);
  Result := RPCBrokerV.Results;

end;

Procedure ListofHOPatientsByPrv(RtnList : TStrings; TM, PRV : String);
begin
if RtnList = nil then RtnList := TStringList.Create;
RtnList.Clear;

  CallV('CRHD HOT PROVIDER PATIENTS', [TM, PRV]);
//  MixedCaseList(RPCBrokerV.Results);
  RtnList.AddStrings(RPCBrokerV.Results);
end;

function SubSetOrderableItems(const StartFrom: string; Direction: Integer): TStrings;
{ returns a pointer to a list of persons (for use in a long list box) -  The return value is
  a pointer to RPCBrokerV.Results, so the data must be used BEFORE the next broker call! }
begin
  CallV('CRHD GET ORDERABLE ITEMS', [StartFrom, Direction]);
//  MixedCaseList(RPCBrokerV.Results);
  Result := RPCBrokerV.Results;
end;


function SubSetOfInPatients(const StartFrom: string; Direction: Integer): TStrings;
{ returns a pointer to a list of patients (for use in a long list box) -  The return value is
  a pointer to RPCBrokerV.Results, so the data must be used BEFORE the next broker call! }
begin
  CallV('CRHD INPT LIST', [StartFrom, Direction]);
  MixedCaseList(RPCBrokerV.Results);
  Result := RPCBrokerV.Results;
end;



end.
