unit frmAList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ORCtrls, ExtCtrls, Menus, VA508AccessibilityManager;

type
  TfrmA = class(TForm)
    cboList: TORComboBox;
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure Exit1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cboListNeedData(Sender: TObject; const StartFrom: String;
      Direction, InsertAt: Integer);
    procedure cboListDblClick(Sender: TObject);
    procedure cboListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    RPCcall : String;
    Selection : String;

  end;

var
  frmA: TfrmA;

function GetList(RPC : String; p : integer): String;

implementation

uses frmMain, OrNet;

{$R *.DFM}


function GetList(RPC : String; p : integer): String;
var
frmA : TfrmA;
tList : TStrings;

begin
   frmA := TfrmA.Create(Application);
  try
     tList := TStringList.Create;
     tList.Clear;

     with frmA do
     begin
     tCallV(tList, RPC, [frmListSelect.DUZ]);
     RPCcall := RPC;
     Result := '';
     if tList.count > 1 then
      begin
        if p > 0 then cboList.Pieces := IntToStr(p)
        else cboList.Pieces := '2';
        cboList.ItemIndex := 0;
        ShowModal;
        Result := Selection;
      end
     else if tList.count = 1 then Result := tList[0];
     end;
  finally
     frmA.Free;
  end;
end;

procedure TfrmA.FormActivate(Sender: TObject);
begin
with cboList do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;
end;

procedure TfrmA.cboListNeedData(Sender: TObject; const StartFrom: String;
  Direction, InsertAt: Integer);
var
tList : TStrings;
begin
tList := TStringList.Create;
tCallV(tList,RPCcall, [frmListSelect.DUZ]);
if tList.count = 1 then Selection := tList[0]
else cboList.ForDataUse(tList);
end;



procedure TfrmA.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TfrmA.cboListDblClick(Sender: TObject);
begin
if cboList.ItemIndex > -1 then Selection := cboList.Items[cboList.ItemIndex]
else Selection := '';
Close;
end;

procedure TfrmA.cboListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If key = VK_RETURN THEN cboListDblClick(cboList);
end;

end.






