unit frmHOListSetup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ORCtrls, ExtCtrls, Menus, VA508AccessibilityManager;

type
  TfrmHOListSetup = class(TForm)
    pnlMain: TPanel;
    Panel1: TPanel;
    btnSubmit: TButton;
    ppPatientDelete: TPopupMenu;
    DeletefromList1: TMenuItem;
    ppProviderDelete: TPopupMenu;
    MenuItem1: TMenuItem;
    Panel2: TPanel;
    cboHOPList: TORComboBox;
    lbxHOPatient: TORListBox;
    pnlPatPrv: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    cboAttn: TORComboBox;
    cboRes: TORComboBox;
    cboIntern: TORComboBox;
    cboFellow: TORComboBox;
    cboMedStudent: TORComboBox;
    cboNurse: TORComboBox;
    Panel3: TPanel;
    cboHOProvider: TORComboBox;
    lbxHOProvider: TORListBox;
    pnlProvInfo: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cboUserClass: TORComboBox;
    edtPager: TORAlignEdit;
    edtPhone: TORAlignEdit;
    ORAutoPanel1: TORAutoPanel;
    btnPatientAdd: TORAlignButton;
    btnPatientRemove: TORAlignButton;
    ORAutoPanel2: TORAutoPanel;
    btnProviderAdd: TORAlignButton;
    btnProviderRemove: TORAlignButton;
    Panel4: TPanel;
    cbxHOMod_Patient: TORCheckBox;
    cbxHOMod_Provider: TORCheckBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SubmitData1: TMenuItem;
    Exit1: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure FormCreate(Sender: TObject);
    procedure cboHOProviderNeedData(Sender: TObject;
      const StartFrom: String; Direction, InsertAt: Integer);
    procedure cboHOPListNeedData(Sender: TObject; const StartFrom: String;
      Direction, InsertAt: Integer);
    procedure btnPatientAddClick(Sender: TObject);
    procedure btnPatientRemoveClick(Sender: TObject);
    procedure btnProviderAddClick(Sender: TObject);
    procedure btnProviderRemoveClick(Sender: TObject);
    procedure btnSubmitClick(Sender: TObject);
    procedure lbxHOPatientClick(Sender: TObject);
    procedure lbxHOProviderClick(Sender: TObject);
    procedure cboUserClassKeyPress(Sender: TObject; var Key: Char);
    procedure cbxHOMod_PatientClick(Sender: TObject);
    procedure cboHOPListDblClick(Sender: TObject);
    procedure cboAttnKeyPause(Sender: TObject);
    procedure cboAttnClick(Sender: TObject);
    procedure cboAttnKeyPress(Sender: TObject; var Key: Char);
    procedure DeletefromList1Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure cboHOProviderDblClick(Sender: TObject);
    procedure cboUserClassChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cboResKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbxHOProviderDblClick(Sender: TObject);
    procedure cboAttnEnter(Sender: TObject);
    procedure edtPhoneChange(Sender: TObject);
    procedure edtPagerChange(Sender: TObject);
    procedure cbxHOMod_ProviderClick(Sender: TObject);
    procedure lbxHOProviderExit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    PatientChanged : Boolean;
    ProviderChanged : Boolean;
    ProviderInfoChanged : Boolean;
    PatPrvInfoChanged : Boolean;
    UserInfo: TStringList;
    PatientPrv: TStringList;
    ActiveCBox : TORComboBox;
    Attn : String;
    Res : String;
    Intern : String;
    Fel : String;
    Mstud : String;
    Nur : String;
    ProvClass : String;
    OPhone : String;
    Pager : String;
    resetfldflag : Boolean;
    ModPatList : integer;
    ModProvList : integer;
    PatientIndx : integer;
    ProviderIndx : integer;
    Procedure ProviderInfo(TM, PRV : String; indx : integer);
    Procedure PatPrvInfo(TM, DFN : String; indx : integer);
    procedure DisableSwitchPatFlds(value : Boolean);
    procedure DisableSwitchPrvFlds(value : Boolean);
    function IsLast5(x: string): Boolean;
    function IsFullSSN(x: string): Boolean;
  public
    { Public declarations }
    Team : String;
    TeamAccess : String;
    procedure SubmitDataToVista(TM, LTYPE, KFG: String; re: TStrings);
  end;


var
  fHOListSetup: TfrmHOListSetup;


procedure HOListSetupP(TM : String);
//function findDup(str : String; slist : TStrings): Boolean;

implementation

uses frmMain, rcore, OrNet, Orfn, frmHOProInfo, Util, UCore;

{$R *.DFM}

Procedure HOListSetupP(TM: String);
var
frmHOListSetup : TfrmHOListSetup;

begin
 frmHOListSetup := TfrmHOListSetup.Create(Application);
 Try
 with frmHOListSetup do
 begin
   Team := TM;
   caption := piece(TM,'^',2);
   lbxHOPatient.Items.Clear;
   lbxHOProvider.Items.Clear;
   tCallV(lbxHOPatient.Items,'CRHD HOT PATIENT LIST', [TM]);

   if lbxHOPatient.Items.Count > 0 then
    If lbxHOPatient.Items[0] <> 'No Patients Found' then
    begin
    lbxHOPatient.ItemIndex := 0;
    lbxHOPatientClick(lbxHOPatient);
    btnPatientRemove.enabled := True;
    end
     else
     begin
     lbxHOPatient.Items.Clear;
      DisableSwitchPatFlds(False);
     end;
      tCallV(lbxHOProvider.Items,'CRHD HOT PROVIDER LIST', [TM]);

   if lbxHOProvider.Items.Count > 0 then
   begin
    lbxHOProvider.ItemIndex := 0;
    lbxHOProviderClick(lbxHOProvider);
    btnProviderRemove.enabled := True;
   end
   else
     DisableSwitchPrvFlds(False);

    ShowModal;


 end;
finally
  frmHOListSetup.Free;
  end;
end;





//*****************frmHOListSetup Starts***************************
procedure TfrmHOListSetup.cboHOPListNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
  procedure ShowMatchingPatients;
    begin
      with lbxHOPatient do
        begin
          if ShortCount > 0 then
            begin
              if ShortCount = 1 then
                begin
                  ItemIndex := 0;
                end;
              Items.Add(LLS_LINE);
              Items.Add(LLS_SPACE);
            end;
          InitLongList('');
        end;
    end;


begin
with cboHOPList do
 begin
    if IsLast5(Text) then
      begin
        ListPtByLast5(Items, Text);
        ShowMatchingPatients;
      end
    else if IsFullSSN(Text) then
      begin
        ListPtByFullSSN(Items, Text);
        ShowMatchingPatients;
      end
 else
// cboHOPList.ForDataUse(SubSetOfPatients(StartFrom, Direction));
cboHOPList.ForDataUse(SubSetOfInPatients(StartFrom, Direction));
end;
end;

procedure TfrmHOListSetup.cboHOProviderNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
begin
//cboHOProvider.ForDataUse(SubSetOfProviders(StartFrom, Direction));
cboHOProvider.ForDataUse(SubSetOfPersons(StartFrom, Direction));
end;

procedure TfrmHOListSetup.FormCreate(Sender: TObject);
begin
Font := frmListSelect.Font;

with cboHOPList do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;

with cboHOProvider do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;

 PatientChanged :=False;
 ProviderChanged := False;
 ProviderInfoChanged := False;
 PatPrvInfoChanged := False;
 PatientIndx := 0;
 ProviderIndx := 0;
 if UserInfo = nil then UserInfo := TStringList.Create;
 if PatientPrv = nil then PatientPrv := TStringList.Create;
 UserInfo.Clear;
 PatientPrv.Clear;
end;

procedure TfrmHOListSetup.btnPatientAddClick(Sender: TObject);
Var
 AccessStatus: Integer;
begin
if (cboHOPList.ItemIndex > -1) and (not findDup(piece(cboHOPList.Items[cboHOPList.ItemIndex],'^',1),lbxHOPatient.Items) )then
 begin
    //check for sensitive patients
    if not AllowAccessToSensitivePatient(Piece(cboHOPList.items.Strings[cboHOPList.itemindex], '^', 1), Piece(cboHOPList.items.Strings[cboHOPList.itemindex], '^', 2), AccessStatus) then exit;

    PatientIndx := lbxHOPatient.Items.Add(cboHOPList.items[cboHOPList.itemindex]);
    PatientChanged := True;
    if lbxHOPatient.ItemIndex <> PatientIndx then lbxHOPatient.ItemIndex := PatientIndx;
    DisableSwitchPatFlds(True);
    Attn := '';
    Res :='';
    Intern := '';
    Fel := '';
    Mstud := '';
    Nur := '';
    if not btnPatientRemove.Enabled then btnPatientRemove.Enabled := True;
    btnSubmit.Enabled := True;
 end;
end;

procedure TfrmHOListSetup.btnPatientRemoveClick(Sender: TObject);
begin
if lbxHOPatient.ItemIndex > -1 then
 begin
 CallV('CRHD HOT DELETE PAT/PRV', [Team, 'P',lbxHOPatient.Items[lbxHOPatient.ItemIndex] ]);
 lbxHOPatient.Items.Delete(lbxHOPatient.ItemIndex);
 PatientChanged := False;
 DisableSwitchPatFlds(False);
 if lbxHOPatient.Items.Count = 0 then btnPatientRemove.Enabled := False;
 end;
end;

procedure TfrmHOListSetup.btnProviderAddClick(Sender: TObject);
var
pstr,str3 : string;
begin
if (cboHOProvider.ItemIndex > -1) and (not findDup(piece(cboHOProvider.Items[cboHOProvider.ItemIndex],'^',1),lbxHOProvider.Items) ) then
 begin
  ProviderIndx := lbxHOProvider.Items.Add(cboHOProvider.items[cboHOProvider.itemindex]);
  if lbxHOProvider.ItemIndex  <> ProviderIndx then lbxHOProvider.ItemIndex := ProviderIndx;
  DisableSwitchPrvFlds(True);
  ProviderChanged := True;
  ProviderInfo(Team, cboHOProvider.Items[cboHOProvider.ItemIndex], lbxHOProvider.ItemIndex );

  pstr := sCALLV('CRHD USER PHONE NUMBERS',[cboHOProvider.Items[cboHOProvider.ItemIndex]]);
  if edtPhone.Text = '' then edtPhone.Text := piece(pstr,'^',1);
  if edtPhone.Text <> '' then
    begin
      str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',3) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',4) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',5)+ '^' + edtPhone.Text;
      lbxHOProvider.Items[ProviderIndx] := str3;
      str3 := '';
    end;
  if edtPager.Text = '' then edtPager.Text := piece(pstr,'^',2);
    if edtPhone.Text <> '' then
    begin
      str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',3) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',4) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',5)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',6) + '^' + edtPager.Text;
      lbxHOProvider.Items[ProviderIndx] := str3;
      str3 := '';
    end;
  ProviderChanged := True;

  if not btnProviderRemove.Enabled then btnProviderRemove.Enabled:= True;
   btnSubmit.Enabled := True;
 end;
end;

procedure TfrmHOListSetup.btnProviderRemoveClick(Sender: TObject);
var
ni : integer;
begin
if lbxHOProvider.ItemIndex > -1 then
  begin
   CallV('CRHD HOT DELETE PAT/PRV', [Team, 'D',lbxHOProvider.Items[lbxHOProvider.ItemIndex] ]);
   ni := CurrentIndex(lbxHOProvider.ItemIndex, lbxHOProvider.Items.count);
   lbxHOProvider.Items.Delete(lbxHOProvider.ItemIndex);
   lbxHOProvider.ItemIndex := ni;
   ProviderChanged := False;
   DisableSwitchPrvFlds(False);
   if lbxHOProvider.ItemIndex > -1 then lbxHOProviderClick(lbxHOProvider);
   if lbxHOProvider.Items.Count = 0 then btnProviderRemove.Enabled := False;
  end;
end;

procedure TfrmHOListSetup.btnSubmitClick(Sender: TObject);
begin
if PatientChanged then SubmitDataToVista(Team,'P','1', lbxHOPatient.Items );
if ProviderChanged then SubmitDataToVista(Team,'D', '1', lbxHOProvider.Items );
Close;
end;

procedure TfrmHOListSetup.SubmitDataToVista(TM, LTYPE, KFG: String; re: TStrings);
begin
 CallV('CRHD HOT MODIFY LIST', [TM, LTYPE, re, KFG]);
end;
procedure TfrmHOListSetup.lbxHOPatientClick(Sender: TObject);
begin
   PatientIndx := lbxHOPatient.ItemIndex;
   if not btnPatientRemove.Enabled then btnPatientRemove.Enabled := True;
   DisableSwitchPatFlds(True);
   PatPrvInfo(Team, piece(lbxHOPatient.Items[lbxHOPatient.ItemIndex],'^',1),lbxHOPatient.ItemIndex )
end;

procedure TfrmHOListSetup.lbxHOProviderClick(Sender: TObject);
begin
ProviderIndx := lbxHOProvider.ItemIndex;
if not btnProviderRemove.Enabled then btnProviderRemove.Enabled := True;
DisableSwitchPrvFlds(True);
ProviderInfo(Team, piece(lbxHOProvider.Items[ProviderIndx],'^',1),ProviderIndx);
end;

//***********************************
Procedure TfrmHOListSetup.ProviderInfo(TM, PRV : String; indx : integer);
   Procedure clearflds;
   begin
     cbxHOMod_Patient.Checked := False;
     cbxHOMod_Provider.Checked := False;
     cboUserClass.Text := '';
     edtPhone.Text := '';
     edtPager.Text :=  '';
   end;

var
sPrv, vPrv ,vstr,vstr1 : String;
vP,vD : integer;
begin
  if UserInfo = nil then UserInfo := TStringList.Create;
  clearflds;
  sPrv :=lbxHOProvider.Items[ProviderIndx] ;
  if pos(piece(sPrv,'^',3),'ATTN^RES^INTERN^FELLOW^MED STUDENT^NURSE')= 0 then
  sPrv := piece(sPrv,'^',1)+ '^' + piece(sPrv, '^',2)+ '^' + '' + '^' + piece(sPrv,'^',4) + '^' + piece(sPrv, '^',5)+ '^' + piece(sPrv,'^',6) + '^' + piece(sPrv, '^',7) ;

   vPrv := sCallV('CRHD HOT PRV INFO', [TM, piece(PRV,'^',1)]);

   cboUserClass.Text := piece(sPrv,'^',3);
   if pos(piece(sPrv,'^',3),'ATTN^RES^INTERN^FELLOW^MED STUDENT^NURSE')= 0 then
     if pos(piece(vPrv,'^',3),'ATTN^RES^INTERN^FELLOW^MED STUDENT^NURSE')> 0 then
      begin
      cboUserClass.Text := piece(vPrv,'^',3);
      end
      else
      cboUserClass.Text := '';

     if (piece(sPrv, '^', 4) <> '0') or (piece(sPrv, '^',4)<> '1') then
     sPrv := piece(sPrv,'^',1)+ '^' + piece(sPrv, '^',2)+ '^' + piece(sPrv,'^',3) + '^' + '0' + '^' + piece(sPrv, '^',5)+ '^' + piece(sPrv,'^',6) + '^' + piece(sPrv, '^',7) ;

    if piece(sPrv,'^',4) ='0' then
      if piece(vPrv,'^',4) = '1' then
      begin
        vP := StrToInt(piece(vPrv,'^',4));
        if vP = 1 then cbxHOMod_Patient.Checked := True;
      end
    else
      cbxHOMod_Patient.Checked := False;

     if (piece(sPrv, '^', 5) <> '0') or (piece(sPrv, '^',5)<> '1') then
     sPrv := piece(sPrv,'^',1)+ '^' + piece(sPrv, '^',2)+ '^' + piece(sPrv,'^',3) + '^' + piece(sPrv, '^',4) + '^' + '0'+ '^' + piece(sPrv,'^',6) + '^' + piece(sPrv, '^',7) ;


    if piece(sPrv,'^',5) ='0' then
      if piece(vPrv,'^',5) = '1' then
      begin
        vD := StrToInt(piece(vPrv,'^',5));
        if vD = 1 then cbxHOMod_Provider.Checked := True;
      end
    else
      cbxHOMod_Provider.Checked := False;


    edtPhone.Text :=  piece(sPrv,'^',6);
    if piece(sPrv,'^',6)='' then
     if piece(vPrv,'^',6) <> '' then edtPhone.Text := piece(vPrv,'^',6);

     edtPager.Text := piece(sPrv,'^',7);
    if piece(sPrv,'^',7) = '' then
     if piece(vPrv,'^',7) <> '' then edtPager.Text := piece(vPrv,'^',7);


    if cbxHOMod_Patient.Checked then vP := 1
    else vP := 0;

    if cbxHOMod_Provider.Checked then vD := 1
    else vD := 0;

     vstr :=  piece(sPrv,'^',1) + '^' + piece(sPrv,'^',2)+ '^'+ cboUserClass.Text + '^' + IntToStr(vP) + '^' + IntToStr(vD)
      + '^' +  edtPhone.Text + '^' + edtPager.Text;

      vstr1 := piece(lbxHOProvider.Items[indx],'~',1);

      if vstr <> vstr1 then lbxHOProvider.Items[indx] := vstr;

    ProviderInfoChanged := False;
end;

procedure TfrmHOListSetup.cboUserClassKeyPress(Sender: TObject;
  var Key: Char);
begin
ProviderInfoChanged := True;
end;

procedure TfrmHOListSetup.cbxHOMod_PatientClick(Sender: TObject);
var
str3 : string;
begin
if Not resetfldflag then
begin
ProviderInfoChanged := True;
if cbxHOMod_Patient.Checked then ModPatList := 1
else ModPatList := 0;
str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',3) + '^' + IntToStr(ModPatList) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',5)+ '^' + piece(lbxHOProvider.Items[ProviderIndx],'^',6) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',7) ;
lbxHOProvider.Items[ProviderIndx] := str3;
ProviderChanged := True;
btnSubmit.Enabled := True;
end;
end;

procedure TfrmHOListSetup.cboHOPListDblClick(Sender: TObject);
begin
btnPatientAddClick(btnPatientAdd);
end;

procedure TfrmHOListSetup.cboAttnKeyPause(Sender: TObject);
begin
if (Sender as TORComboBox).Text <> '' then cboAttnClick((Sender as TORComboBox));
end;

procedure TfrmHOListSetup.cboAttnClick(Sender: TObject);
var
str, str2,str3 : String;
begin
  str :=  (Sender as TORComboBox).Text;   //str
  (Sender as TORComboBox).Text := '';
  (Sender as TORComboBox).Items.Clear;
  if str <> '' then
    begin
      str2 := ProviderSelection(Team, str) ;
      if str2 <> '' then
        begin
          str3 := piece(str2,'^',1) + '^' + piece(str2,'^',2);

         (Sender as TORComboBox).Items.Add(str3);
         case  (Sender as TORComboBox).Tag of
           3 : Attn := str3;
           4 : Res := str3;
           5 : Intern := str3;
           6 : Fel := str3;
           7 : Mstud:= str3;
           8 : Nur := str3;
         end;
         str3 :=piece(lbxHOPatient.Items[PatientIndx],'*',1)+ '*' + piece(lbxHOPatient.Items[PatientIndx],'^',1) + ';' + Attn + ';' + Res + ';' + Intern + ';' + Fel + ';' + Mstud + ';' + Nur;

         lbxHOPatient.Items[PatientIndx] := str3;
         PatientChanged := True;
          btnSubmit.Enabled := True;
         if (Sender as TORComboBox).Items.count >0 then (Sender as TORComboBox).ItemIndex := 0;
        end;
    end;
end;

procedure TfrmHOListSetup.PatPrvInfo(TM, DFN: String; indx: integer);
   Procedure clearflds;
   begin
     cboAttn.Clear;
     cboRes.Clear;
     cboIntern.Clear;
     cboFellow.Clear;
     cboMedStudent.Clear;
     cboNurse.Clear;
     Attn := '';
     Res :='';
     Intern := '';
     Fel := '';
     Mstud := '';
     Nur := '';
   end;
var
sPrv : String;
vstr, vstr1 : String;
begin
   if PatientPrv = nil then PatientPrv := TStringList.Create;
   clearflds;
   sPrv := piece(lbxHOPatient.Items[indx],'*',2);
   Attn :=  piece(sPrv,';',2);
   if pos('+',attn)>0 then PiecesToList(Attn,'+',cboAttn.items)
   else cboAttn.Items.Add(Attn);
   if cboAttn.Items.count>0 then cboAttn.ItemIndex := 0;


   Res :=  piece(sPrv,';',3);
   if pos('+',res)>0 then PiecesToList(Res,'+',cboRes.items)
   else cboRes.Items.Add(Res);
   if cboRes.Items.count>0 then cboRes.ItemIndex := 0;

   Intern :=  piece(sPrv,';',4);
   if pos('+',Intern)>0 then PiecesToList(Intern,'+',cboIntern.items)
   else cboIntern.Items.Add(Intern);
   if cboIntern.Items.count>0 then cboIntern.ItemIndex := 0;

   Fel :=  piece(sPrv,';',5);
   if pos('+',Fel)>0 then PiecesToList(Fel,'+',cboFellow.items)
   else cboFellow.Items.Add(Fel);
   if cboFellow.Items.count>0 then cboFellow.ItemIndex := 0;

   Mstud :=  piece(sPrv,';',6);
   if pos('+',Mstud)>0 then PiecesToList(Mstud,'+',cboMedStudent.items)
   else cboMedStudent.Items.Add(Mstud);
   if cboMedStudent.Items.count>0 then cboMedStudent.ItemIndex := 0;

   Nur :=  piece(sPrv,';',7);
   if pos('+',Nur)>0 then PiecesToList(Nur,'+',cboNurse.items)
   else cboNurse.Items.Add(Nur);
   if cboNurse.Items.count>0 then cboNurse.ItemIndex := 0;

   vstr := Attn + ';' + Res + ';'+ Intern + ';' + Fel + ';' + Mstud
   + ';' +  Nur ;

   vstr1 := piece(lbxHOPatient.Items[indx],';',1) + ';' + vstr;

   lbxHOPatient.Items[indx]:= vstr1;

   PatPrvInfoChanged := False;
end;

procedure TfrmHOListSetup.cboAttnKeyPress(Sender: TObject; var Key: Char);
begin
PatPrvInfoChanged := True;
end;

procedure TfrmHOListSetup.DeletefromList1Click(Sender: TObject);
begin
btnPatientRemoveClick(btnPatientRemove);
end;

procedure TfrmHOListSetup.MenuItem1Click(Sender: TObject);
begin
btnProviderRemoveClick(btnProviderRemove);
end;

procedure TfrmHOListSetup.DisableSwitchPatFlds(value : Boolean);
begin
   Label4.Enabled := Value;
   Label5.Enabled := Value;
   Label6.Enabled := Value;
   Label7.Enabled := Value;
   Label8.Enabled := Value;
   Label9.Enabled := Value;
   cboAttn.Clear;
   cboAttn.Enabled :=Value;
   cboRes.Clear;
   cboRes.Enabled := Value;
   cboIntern.Clear;
   cboIntern.Enabled := Value;
   cboFellow.Clear;
   cboFellow.Enabled := Value;
   cboMedStudent.Clear;
   cboMedStudent.Enabled := Value;
   cboNurse.Clear;
   cboNurse.Enabled := Value;
end;

procedure TfrmHOListSetup.DisableSwitchPrvFlds(value: Boolean);
begin
    resetfldflag := True;
    cbxHOMod_Patient.Checked := False;
    cbxHOMod_Patient.Enabled := Value;
    cbxHOMod_Provider.Checked := False;
    cbxHOMod_Provider.Enabled := Value;
    cboUserClass.Text := '';
    cboUserClass.ItemIndex := -1;
    cboUserClass.Enabled := Value;
    edtPhone.Text := '';
    edtPhone.Enabled := Value;
    edtPager.Text := '';
    edtPager.Enabled := Value;
    Label1.Enabled := Value;
    Label2.Enabled := Value;
    Label3.Enabled := Value;
    resetfldflag := False;
end;


procedure TfrmHOListSetup.cboHOProviderDblClick(Sender: TObject);
begin
btnProviderAddClick(btnProviderAdd);
end;

procedure TfrmHOListSetup.cboUserClassChange(Sender: TObject);
var
str3 : String;
begin
if Not resetfldflag then
begin
ProviderInfoChanged := True;
ProvClass := cboUserClass.Text;
if lbxHOProvider.Items.Count > 0 then
begin
str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + ProvClass + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',4) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',5)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',6) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',7) ;
lbxHOProvider.Items[ProviderIndx] := str3;
ProviderChanged := True;
btnSubmit.Enabled := True;
end;
end;
end;


procedure TfrmHOListSetup.FormShow(Sender: TObject);
var
s : String;
begin
   s := sCallV('CRHD HOT CAN EDIT',[Team, frmListSelect.DUZ]) ;
   if piece(s,'^',1)= '0' then
   begin
   Panel2.Visible := False;
   Panel2.Align := alClient;
   Height := Constraints.MinHeight;
   end;

   if piece(s,'^',2)= '0' then
    begin
     Panel3.Visible := False;
     Height := Constraints.MinHeight;
    end;
   if cboHOPList.CanFocus then
    cboHOPList.SetFocus;
end;

procedure TfrmHOListSetup.cboResKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If (Key = VK_DELETE) then
 begin
  PatPrvInfoChanged := True;
 end;
end;

function TfrmHOListSetup.IsFullSSN(x: string): Boolean;
var
  i: integer;
begin
  Result := False;
  if (Length(x) < 9) or (Length(x) > 12) then Exit;
  case Length(x) of
    9:  // no dashes, no 'P'
        for i := 1 to 9 do if not (x[i] in ['0'..'9']) then Exit;
   10:  // no dashes, with 'P'
        begin
          for i := 1 to 9 do if not (x[i] in ['0'..'9']) then Exit;
          if (Uppercase(x[10]) <> 'P') then Exit;
        end;
   11:  // dashes, no 'P'
        begin
          if (x[4] <> '-') or (x[7] <> '-') then Exit;
          x := Copy(x,1,3) + Copy(x,5,2) + Copy(x,8,4);
          for i := 1 to 9 do if not (x[i] in ['0'..'9']) then Exit;
        end;
   12:  // dashes, with 'P'
        begin
          if (x[4] <> '-') or (x[7] <> '-') then Exit;
          x := Copy(x,1,3) + Copy(x,5,2) + Copy(x,8,5);
          for i := 1 to 9 do if not (x[i] in ['0'..'9']) then Exit;
          if UpperCase(x[10]) <> 'P' then Exit;
        end;
  end;
  Result := True;
end;

function TfrmHOListSetup.IsLast5(x: string): Boolean;
var
  i: Integer;
begin
  Result := False;
  if not ((Length(x) = 4) or (Length(x) = 5)) then Exit;
  if Length(x) = 5 then
  begin
    if not (x[1] in ['A'..'Z', 'a'..'z']) then Exit;
    x := Copy(x, 2, 4);
  end;
  for i := 1 to 4 do if not (x[i] in ['0'..'9']) then Exit;
  Result := True;
end;

procedure TfrmHOListSetup.lbxHOProviderDblClick(Sender: TObject);
begin

if ActiveCBox <> nil then
  with ActiveCBox do
   begin
    Text :='';
    Items.Clear;
    Items.Add(OrFn.pieces(lbxHOProvider.Items[lbxHOProvider.ItemIndex],'^',1,2));
    if Items.Count >0 then ItemIndex := 0;
    PatPrvInfoChanged := True;
   end;
end;

procedure TfrmHOListSetup.cboAttnEnter(Sender: TObject);
begin
ActiveCBox := (Sender as TORComboBox);
end;

procedure TfrmHOListSetup.edtPhoneChange(Sender: TObject);
var
str3 : String;
begin
if Not resetfldflag then
begin
OPhone := edtPhone.Text;
str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',3) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',4) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',5)+ '^' + OPhone + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',7) ;
lbxHOProvider.Items[ProviderIndx] := str3;
ProviderChanged := True;
btnSubmit.Enabled := True;
end;
end;

procedure TfrmHOListSetup.edtPagerChange(Sender: TObject);
var
str3 : String;
begin
if Not resetfldflag then
begin
Pager := edtPager.Text;
str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',3) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',4) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',5)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',6)+ '^' + Pager ;
lbxHOProvider.Items[ProviderIndx] := str3;
ProviderChanged := True;
btnSubmit.Enabled := True;
end;
end;

procedure TfrmHOListSetup.cbxHOMod_ProviderClick(Sender: TObject);
var
str3 : String;
begin
if Not resetfldflag then
begin
ProviderInfoChanged := True;
if cbxHOMod_Provider.Checked then ModProvList := 1
else ModProvList := 0;
str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',3) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',4) + '^' + IntToStr(ModProvList)+ '^' + piece(lbxHOProvider.Items[ProviderIndx],'^',6) + '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',7) ;
lbxHOProvider.Items[ProviderIndx] := str3;
ProviderChanged := True;
btnSubmit.Enabled := True;
end;
end;

procedure TfrmHOListSetup.lbxHOProviderExit(Sender: TObject);
var
str3 : String;
begin
  if lbxHOProvider.Items.Count > 0 then
 begin
  ProvClass := cboUserClass.Text;
  str3 :=piece(lbxHOProvider.Items[ProviderIndx],'^',1)+ '^' + piece(lbxHOProvider.Items[ProviderIndx], '^',2)+ '^' + ProvClass + '^' + IntToStr(ModPatList) + '^' + IntToStr(ModProvList)+ '^' + OPhone + '^' + Pager ;
  lbxHOProvider.Items[ProviderIndx] := str3;
  ProviderChanged := True;
 end
 else ProviderIndx := -1;
end;

procedure TfrmHOListSetup.Button1Click(Sender: TObject);
begin
Close;
end;

procedure TfrmHOListSetup.FormResize(Sender: TObject);
var
w, h, h2 : integer;
begin
w := Trunc(pnlMain.Width /4);
h := Trunc(pnlMain.Height/2);
Panel2.Height := h;
h2 := Trunc(h/12);

Label4.Height := h2;
Label5.Height := h2;
Label6.Height := h2;
Label7.Height := h2;
Label8.Height := h2;
Label9.Height := h2;

cboAttn.Height := h2;
cboRes.Height := h2;
cboIntern.Height := h2;
cboFellow.Height := h2;
cboMedStudent.Height := h2;
cboNurse.Height := h2;
cboHOPList.Width := w;
lbxHOPatient.Width := w;
pnlPatPrv.Width := w;
cboHOProvider.Width := w;
lbxHOProvider.Width := w;
pnlProvInfo.Width := w;
end;

end.

